# AnyAtomicType Class Reference

`#include <AnyAtomicType.hpp>`

Inheritance diagram for AnyAtomicType:

[legend]
List of all members.

## Public Types

typedef RefCountPointer< const AnyAtomicType > | Ptr

enum

AtomicObjectType {
ANY_SIMPLE_TYPE = 0, ANY_URI = 1, BASE_64_BINARY = 2, BOOLEAN = 3,
DATE = 4, DATE_TIME = 5, DAY_TIME_DURATION = 6, DECIMAL = 7,
DOUBLE = 8, DURATION = 9, FLOAT = 10, G_DAY = 11,
G_MONTH = 12, G_MONTH_DAY = 13, G_YEAR = 14, G_YEAR_MONTH = 15,
HEX_BINARY = 16, NOTATION = 17, QNAME = 18, STRING = 19,
TIME = 20, UNTYPED_ATOMIC = 21, YEAR_MONTH_DURATION = 22, NumAtomicObjectTypes = 23
}

## Public Member Functions

virtual bool | isAtomicValue () const
virtual bool | isNode () const
virtual bool | isNumericValue () const
virtual bool | isDateOrTimeTypeValue () const
virtual const XMLCh * | getPrimitiveTypeURI () const
virtual const XMLCh * | getPrimitiveTypeName () const =0
virtual const XMLCh * | getTypeURI () const =0
virtual const XMLCh * | getTypeName () const =0
AnyAtomicType::Ptr | castAs (const XMLCh *targetURI, const XMLCh *targetType, const DynamicContext *context) const
virtual bool | castable (const XMLCh *targetURI, const XMLCh *targetType, const DynamicContext *context) const
virtual const XMLCh * | asString (const DynamicContext *context) const =0
virtual bool | equals (const AnyAtomicType::Ptr &target, const DynamicContext *context) const =0
virtual bool | isOfType (const XMLCh *targetURI, const XMLCh *targetType, const DynamicContext *context) const
virtual bool | isInstanceOfType (const XMLCh *targetURI, const XMLCh *targetType, const StaticContext *context) const
bool | castIsSupported (AtomicObjectType targetIndex, const DynamicContext *context) const
| Returns true if (a) both the input type and the target type are built-in schema types and cast is supported for the combination.
virtual AtomicObjectType | getPrimitiveTypeIndex () const =0

## Static Public Attributes

static const XMLCh | fgDT_ANYATOMICTYPE []
static const XMLCh | fgDT_ANYATOMICTYPE_XERCESHASH []

## Protected Member Functions

virtual AnyAtomicType::Ptr | castAsInternal (AtomicObjectType targetIndex, const XMLCh *targetURI, const XMLCh *targetType, const DynamicContext *context) const

## Classes

class | CastTable

## Member Typedef Documentation

typedef RefCountPointer<const AnyAtomicType> AnyAtomicType::Ptr

| Reimplemented from Item. Reimplemented in ATBooleanOrDerived, ATDateOrDerived, ATDateTimeOrDerived, ATDecimalOrDerived, ATDoubleOrDerived, ATDurationOrDerived, ATFloatOrDerived, ATGDayOrDerived, ATGMonthDayOrDerived, ATGMonthOrDerived, ATGYearMonthOrDerived, ATGYearOrDerived, ATQNameOrDerived, ATStringOrDerived, ATTimeOrDerived, DateOrTimeType, and Numeric.

## Member Enumeration Documentation

enum AnyAtomicType::AtomicObjectType

Enumerator:

  ANY_SIMPLE_TYPE |
  ANY_URI |
  BASE_64_BINARY |
  BOOLEAN |
  DATE |
  DATE_TIME |
  DAY_TIME_DURATION |
  DECIMAL |
  DOUBLE |
  DURATION |
  FLOAT |
  G_DAY |
  G_MONTH |
  G_MONTH_DAY |
  G_YEAR |
  G_YEAR_MONTH |
  HEX_BINARY |
  NOTATION |
  QNAME |
  STRING |
  TIME |
  UNTYPED_ATOMIC |
  YEAR_MONTH_DURATION |
  NumAtomicObjectTypes |

## Member Function Documentation

virtual const XMLCh* AnyAtomicType::asString | ( | const DynamicContext * | context | ) | const`[pure virtual]`

Implements Item.

Implemented in ATAnySimpleType, ATAnyURIOrDerived, ATBase64BinaryOrDerived, ATBooleanOrDerived, ATDateOrDerived, ATDateTimeOrDerived, ATDecimalOrDerived, ATDoubleOrDerived, ATDurationOrDerived, ATFloatOrDerived, ATGDayOrDerived, ATGMonthDayOrDerived, ATGMonthOrDerived, ATGYearMonthOrDerived, ATGYearOrDerived, ATHexBinaryOrDerived, ATNotationOrDerived, ATQNameOrDerived, ATStringOrDerived, ATTimeOrDerived, ATUntypedAtomic, and Numeric.

virtual bool AnyAtomicType::castable | ( | const XMLCh * | targetURI,
|  | const XMLCh * | targetType,
|  | const DynamicContext * | context
| ) | const`[virtual]`

AnyAtomicType::Ptr AnyAtomicType::castAs | ( | const XMLCh * | targetURI,
|  | const XMLCh * | targetType,
|  | const DynamicContext * | context
| ) | const

virtual AnyAtomicType::Ptr AnyAtomicType::castAsInternal | ( | AtomicObjectType | targetIndex,
|  | const XMLCh * | targetURI,
|  | const XMLCh * | targetType,
|  | const DynamicContext * | context
| ) | const`[protected, virtual]`

bool AnyAtomicType::castIsSupported | ( | AtomicObjectType | targetIndex,
|  | const DynamicContext * | context
| ) | const

Returns true if (a) both the input type and the target type are built-in schema types and cast is supported for the combination.

(b) the input type is a derived atomic type and the target type is a supertype of the input type (c) the target type is a derived atomic type and the input type is xs:string, xs:anySimpleType, or a supertype of the target type. (d) If a primitive type P1 can be cast into a primitive type P2, then any subtype of P1 can be cast into any subtype of P2

virtual bool AnyAtomicType::equals | ( | const AnyAtomicType::Ptr & | target,
|  | const DynamicContext * | context
| ) | const`[pure virtual]`

| Implemented in ATAnySimpleType, ATAnyURIOrDerived, ATBase64BinaryOrDerived, ATBooleanOrDerived, ATDateOrDerived, ATDateTimeOrDerived, ATDurationOrDerived, ATGDayOrDerived, ATGMonthDayOrDerived, ATGMonthOrDerived, ATGYearMonthOrDerived, ATGYearOrDerived, ATHexBinaryOrDerived, ATNotationOrDerived, ATQNameOrDerived, ATStringOrDerived, ATTimeOrDerived, ATUntypedAtomic, and Numeric.

virtual AtomicObjectType AnyAtomicType::getPrimitiveTypeIndex | ( |  | ) | const`[pure virtual]`

Implemented in ATAnySimpleType, ATAnyURIOrDerived, ATBase64BinaryOrDerived, ATBooleanOrDerived, ATDateOrDerived, ATDateTimeOrDerived, ATDecimalOrDerived, ATDoubleOrDerived, ATDurationOrDerived, ATFloatOrDerived, ATGDayOrDerived, ATGMonthDayOrDerived, ATGMonthOrDerived, ATGYearMonthOrDerived, ATGYearOrDerived, ATHexBinaryOrDerived, ATNotationOrDerived, ATQNameOrDerived, ATStringOrDerived, ATTimeOrDerived, ATUntypedAtomic, and Numeric.

virtual const XMLCh* AnyAtomicType::getPrimitiveTypeName | ( |  | ) | const`[pure virtual]`

Implemented in ATAnySimpleType, ATAnyURIOrDerived, ATBase64BinaryOrDerived, ATBooleanOrDerived, ATDateOrDerived, ATDateTimeOrDerived, ATDecimalOrDerived, ATDoubleOrDerived, ATDurationOrDerived, ATFloatOrDerived, ATGDayOrDerived, ATGMonthDayOrDerived, ATGMonthOrDerived, ATGYearMonthOrDerived, ATGYearOrDerived, ATHexBinaryOrDerived, ATNotationOrDerived, ATQNameOrDerived, ATStringOrDerived, ATTimeOrDerived, ATUntypedAtomic, and Numeric.

virtual const XMLCh* AnyAtomicType::getPrimitiveTypeURI | ( |  | ) | const`[virtual]`

virtual const XMLCh* AnyAtomicType::getTypeName | ( |  | ) | const`[pure virtual]`

Implements Item.

Implemented in ATAnySimpleType, ATAnyURIOrDerived, ATBase64BinaryOrDerived, ATBooleanOrDerived, ATDateOrDerived, ATDateTimeOrDerived, ATDecimalOrDerived, ATDoubleOrDerived, ATDurationOrDerived, ATFloatOrDerived, ATGDayOrDerived, ATGMonthDayOrDerived, ATGMonthOrDerived, ATGYearMonthOrDerived, ATGYearOrDerived, ATHexBinaryOrDerived, ATNotationOrDerived, ATQNameOrDerived, ATStringOrDerived, ATTimeOrDerived, ATUntypedAtomic, and Numeric.

virtual const XMLCh* AnyAtomicType::getTypeURI | ( |  | ) | const`[pure virtual]`

Implements Item.

Implemented in ATAnySimpleType, ATAnyURIOrDerived, ATBase64BinaryOrDerived, ATBooleanOrDerived, ATDateOrDerived, ATDateTimeOrDerived, ATDecimalOrDerived, ATDoubleOrDerived, ATDurationOrDerived, ATFloatOrDerived, ATGDayOrDerived, ATGMonthDayOrDerived, ATGMonthOrDerived, ATGYearMonthOrDerived, ATGYearOrDerived, ATHexBinaryOrDerived, ATNotationOrDerived, ATQNameOrDerived, ATStringOrDerived, ATTimeOrDerived, ATUntypedAtomic, and Numeric.

virtual bool AnyAtomicType::isAtomicValue | ( |  | ) | const`[virtual]`

| Implements Item.

virtual bool AnyAtomicType::isDateOrTimeTypeValue | ( |  | ) | const`[virtual]`

| Reimplemented in DateOrTimeType.

virtual bool AnyAtomicType::isInstanceOfType | ( | const XMLCh * | targetURI,
|  | const XMLCh * | targetType,
|  | const StaticContext * | context
| ) | const`[virtual]`

virtual bool AnyAtomicType::isNode | ( |  | ) | const`[virtual]`

| Implements Item.

virtual bool AnyAtomicType::isNumericValue | ( |  | ) | const`[virtual]`

| Reimplemented in Numeric.

virtual bool AnyAtomicType::isOfType | ( | const XMLCh * | targetURI,
|  | const XMLCh * | targetType,
|  | const DynamicContext * | context
| ) | const`[virtual]`

## Member Data Documentation

const XMLCh AnyAtomicType::fgDT_ANYATOMICTYPE[]`[static]`

const XMLCh AnyAtomicType::fgDT_ANYATOMICTYPE_XERCESHASH[]`[static]`

The documentation for this class was generated from the following file:

- AnyAtomicType.hpp